package de.accso.flexinale.security;

import de.accso.flexinale.common.shared_kernel.Identifiable;
import de.accso.flexinale.security.api_contract.BesucherRetriever;
import de.accso.flexinale.security.infrastructure.persistence.BenutzerEntity;
import de.accso.flexinale.security.infrastructure.persistence.BenutzerJpaRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Profile;
import org.springframework.http.HttpStatus;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

@Service
@Profile({ "!testdata-ticketing" })
public class BenutzerDetailsService implements UserDetailsService, BesucherRetriever {

    @Autowired
    private BenutzerJpaRepository benutzerJpaRepository;

    @Override
    public UserDetails loadUserByUsername(final String login) throws UsernameNotFoundException {
        Optional<BenutzerEntity> benutzer = benutzerJpaRepository.findByLogin(login);
        if (benutzer.isEmpty()) { // login is unique
            throw new UsernameNotFoundException("no Benutzer %s found".formatted(login));
        }
        return new UserPrincipal(benutzer.get());
    }

    @Override
    public Identifiable.Id getIdOfLoggedInBesucher() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        String userLogin = authentication.getName();
        Optional<BenutzerEntity> benutzer = benutzerJpaRepository.findByLogin(userLogin);

        if (benutzer.isEmpty()) {
            throw new ResponseStatusException(HttpStatus.EXPECTATION_FAILED,
                    "None or more than one Besucher with login " + userLogin);
        }
        else {
            return benutzer.get().id();
        }
    }
}
